"""python naming convention

Revision ID: 3b3a2b5dc780
Revises: 7c2bb11c71bc
Create Date: 2022-01-28 12:21:12.344181+01:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_extension import PGExtension
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "3b3a2b5dc780"
down_revision = "7c2bb11c71bc"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    op.rename_table("ContactMoment", "contact_moment")
    op.drop_index("ix_ContactMoment_contact", table_name="contact_moment")
    op.drop_index("ix_ContactMoment_id", table_name="contact_moment")
    op.drop_index("ix_ContactMoment_sid", table_name="contact_moment")

    op.create_index(op.f("ix_contact_moment_id"), "contact_moment", ["id"], unique=True)
    op.create_index(op.f("ix_contact_moment_sid"), "contact_moment", ["sid"], unique=False)
    op.create_index(
        op.f("ix_contact_moment_contact"),
        "contact_moment",
        ["contact"],
        unique=False,
    )
    # droped here as it depends on the CustomField_pkey
    op.drop_constraint("CustomFieldValues_contact_moment_id_fkey", "CustomFieldValues")
    op.drop_constraint("ContactMoment_pkey", "contact_moment")

    op.create_primary_key("contact_moment_pkey", "contact_moment", ["sid"])
    op.drop_constraint("ContactMoment_uuid_key", "contact_moment")
    op.create_unique_constraint("contact_moment_uuid_key", "contact_moment", ["uuid"])

    op.rename_table("CustomFieldValues", "custom_field_values")

    op.drop_index("ix_CustomFieldValues_sid", table_name="custom_field_values")

    op.drop_index(
        "ix_CustomFieldValues_contact_moment_id",
        table_name="custom_field_values",
    )

    op.create_index(
        op.f("ix_custom_field_values_contact_moment_id"),
        "custom_field_values",
        ["contact_moment_id"],
        unique=False,
    )
    op.create_index(
        op.f("ix_custom_field_values_sid"),
        "custom_field_values",
        ["sid"],
        unique=False,
    )

    op.drop_constraint("CustomFieldValues_pkey", "custom_field_values")
    op.create_primary_key("custom_field_values_pkey", "custom_field_values", ["sid"])

    op.rename_table("CustomField", "custom_field")
    op.drop_index("ix_CustomField_name", table_name="custom_field")
    op.drop_index("ix_CustomField_sid", table_name="custom_field")
    op.drop_index("ix_CustomField_sort_order", table_name="custom_field")

    op.create_index(op.f("ix_custom_field_name"), "custom_field", ["name"], unique=True)
    op.create_index(op.f("ix_custom_field_sid"), "custom_field", ["sid"], unique=False)
    op.create_index(
        op.f("ix_custom_field_sort_order"),
        "custom_field",
        ["sort_order"],
        unique=False,
    )

    op.drop_constraint(
        "CustomFieldValues_custom_field_id_fkey",
        table_name="custom_field_values",
    )

    op.drop_constraint("CustomField_pkey", "custom_field")

    op.create_primary_key("custom_field_pkey", "custom_field", ["sid"])
    op.drop_constraint("CustomField_uuid_key", "custom_field")
    op.create_unique_constraint("custom_field_uuid_key", "custom_field", ["uuid"])
    op.create_foreign_key(
        "custom_field_values_contact_moment_id_fkey",
        "custom_field_values",
        "contact_moment",
        ["contact_moment_id"],
        ["sid"],
    )

    op.create_foreign_key(
        "custom_field_values_custom_field_id_fkey",
        "custom_field_values",
        "custom_field",
        ["custom_field_id"],
        ["sid"],
    )

    op.execute(
        'ALTER SEQUENCE "ContactMoment_id_seq" RENAME TO "contact_moment_id_seq"'  # noqa: E501
    )
    op.execute(
        'ALTER SEQUENCE "ContactMoment_sid_seq" RENAME TO "contact_moment_sid_seq"'  # noqa: E501
    )

    op.execute(
        'ALTER SEQUENCE "CustomFieldValues_sid_seq" RENAME TO "custom_field_values_sid_seq"'  # noqa: E501
    )
    op.execute('ALTER SEQUENCE "CustomField_sid_seq" RENAME TO "custom_field_sid_seq"')

    op.execute(
        """
    CREATE OR REPLACE FUNCTION contact_moment_generate_id()
    RETURNS character varying
    LANGUAGE plpgsql
    AS $function$
                DECLARE
                v_result      varchar := 'CM-';
                value_numeric numeric;
                begin
                    SELECT nextval('"contact_moment_id_seq"') INTO value_numeric;\n IF value_numeric > 9999 THEN \n v_result := v_result || value_numeric;\n ELSE \n v_result := v_result || to_char(value_numeric, 'FM0000'); \n  END IF;\n return v_result;\n END;\n $function$\n; """  # noqa: E501
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    public_uuid_ossp = PGExtension(schema="public", signature="uuid-ossp")
    op.create_entity(public_uuid_ossp)

    op.create_table(
        "CustomField",
        sa.Column(
            "sid",
            sa.INTEGER(),
            server_default=sa.text("nextval('\"CustomField_sid_seq\"'::regclass)"),
            autoincrement=True,
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(),
            server_default=sa.text("gen_random_uuid()"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("name", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("description", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("required", sa.BOOLEAN(), autoincrement=False, nullable=True),
        sa.Column(
            "type",
            postgresql.ENUM("string", "text", "select", name="customfieldtypes"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("sort_order", sa.INTEGER(), autoincrement=False, nullable=False),
        sa.Column(
            "options",
            postgresql.JSON(astext_type=sa.Text()),
            autoincrement=False,
            nullable=True,
        ),
        sa.PrimaryKeyConstraint("sid", name="CustomField_pkey"),
        sa.UniqueConstraint("uuid", name="CustomField_uuid_key"),
        postgresql_ignore_search_path=False,
    )
    op.create_index(
        "ix_CustomField_sort_order",
        "CustomField",
        ["sort_order"],
        unique=False,
    )
    op.create_index("ix_CustomField_sid", "CustomField", ["sid"], unique=False)
    op.create_index("ix_CustomField_name", "CustomField", ["name"], unique=False)
    op.create_table(
        "ContactMoment",
        sa.Column(
            "sid",
            sa.INTEGER(),
            server_default=sa.text("nextval('\"ContactMoment_sid_seq\"'::regclass)"),
            autoincrement=True,
            nullable=False,
        ),
        sa.Column(
            "id",
            sa.VARCHAR(),
            server_default=sa.text("contact_moment_generate_id()"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(),
            server_default=sa.text("gen_random_uuid()"),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("contact", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column(
            "created_at",
            postgresql.TIMESTAMP(),
            autoincrement=False,
            nullable=True,
        ),
        sa.Column(
            "updated_at",
            postgresql.TIMESTAMP(),
            autoincrement=False,
            nullable=True,
        ),
        sa.Column("created_by_id", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.Column("created_by_name", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.PrimaryKeyConstraint("sid", name="ContactMoment_pkey"),
        sa.UniqueConstraint("uuid", name="ContactMoment_uuid_key"),
        postgresql_ignore_search_path=False,
    )
    op.create_index("ix_ContactMoment_sid", "ContactMoment", ["sid"], unique=False)
    op.create_index("ix_ContactMoment_id", "ContactMoment", ["id"], unique=False)
    op.create_index("ix_ContactMoment_contact", "ContactMoment", ["contact"], unique=False)
    op.create_table(
        "CustomFieldValues",
        sa.Column(
            "sid",
            sa.INTEGER(),
            server_default=sa.text("nextval('\"CustomFieldValues_sid_seq\"'::regclass)"),
            autoincrement=True,
            nullable=False,
        ),
        sa.Column(
            "contact_moment_id",
            sa.INTEGER(),
            autoincrement=False,
            nullable=True,
        ),
        sa.Column(
            "custom_field_id",
            sa.INTEGER(),
            autoincrement=False,
            nullable=False,
        ),
        sa.Column("value", sa.VARCHAR(), autoincrement=False, nullable=True),
        sa.ForeignKeyConstraint(
            ["contact_moment_id"],
            ["ContactMoment.sid"],
            name="CustomFieldValues_contact_moment_id_fkey",
        ),
        sa.ForeignKeyConstraint(
            ["custom_field_id"],
            ["CustomField.sid"],
            name="CustomFieldValues_custom_field_id_fkey",
        ),
        sa.PrimaryKeyConstraint("sid", name="CustomFieldValues_pkey"),
    )
    op.create_index("ix_CustomFieldValues_sid", "CustomFieldValues", ["sid"], unique=False)
    op.create_index(
        "ix_CustomFieldValues_contact_moment_id",
        "CustomFieldValues",
        ["contact_moment_id"],
        unique=False,
    )
    op.drop_index(op.f("ix_custom_field_values_sid"), table_name="custom_field_values")
    op.drop_index(
        op.f("ix_custom_field_values_contact_moment_id"),
        table_name="custom_field_values",
    )
    op.drop_table("custom_field_values")
    op.drop_index(op.f("ix_custom_field_sort_order"), table_name="custom_field")
    op.drop_index(op.f("ix_custom_field_sid"), table_name="custom_field")
    op.drop_index(op.f("ix_custom_field_name"), table_name="custom_field")
    op.drop_table("custom_field")
    op.drop_index(op.f("ix_contact_moment_sid"), table_name="contact_moment")
    op.drop_index(op.f("ix_contact_moment_id"), table_name="contact_moment")
    op.drop_index(op.f("ix_contact_moment_contact"), table_name="contact_moment")
    op.drop_table("contact_moment")
    # ### end Alembic commands ###
